XIncludeFile "OWire_Module.pbi" ;   .
XIncludeFile ".pbf"         ;   .

UseModule OWire ;       "OWire_Module.pbi".

Enumeration OW_ErrCode
  #OW_Err_CRC ;  CRC.
EndEnumeration

Structure DS ;    .
  ID.OW_SN    ;  .
  Temp.f      ;   .
  ErrCode.a   ;  .
EndStructure

Global NewList DS_List.DS() ;  .

Procedure.s GetErrString(Err) ;   .
  Protected String.s
  
  Select Err
    Case #OW_Err_OK       : String = " "
    Case #OW_Err_Port     : String = "  COM "
    Case #OW_Err_NoDevice : String = "   '1-Wire' "
    Case #OW_Err_IO       : String = "  "
    Case #OW_Err_BaudRate : String = "   "
    Case #OW_Err_Search   : String = "   '1-Wire' "
    Case #OW_Err_BadParam : String = "   "
    Case #OW_Err_NoData   : String = " "
    Case #OW_Err_CRC      : String = " CRC"
  EndSelect
  
  ProcedureReturn String
EndProcedure

Procedure.s SN_Text(*x.OW_SN)
  Protected String.s, i
  
  String = RSet(Hex(*x\Type), 2, "0")+"-"
  
  For i=5 To 0 Step -1
    String + RSet(Hex(*x\Number[i]), 2, "0")
  Next i
  
  String + "-"+RSet(Hex(*x\CRC), 2, "0")
  
  ProcedureReturn String
EndProcedure

Procedure Find() ;  
  ID.OW_SN ;    .
  
  If OW_PortID()=0
    MessageRequester("", "  COM ")
    ProcedureReturn ;   .
  EndIf
  
  ClearList(DS_List())          ;  .
  ClearGadgetItems(#ListIcon_0) ;    .
  
  x=0 ;   .
  
  OW_SearchROM_Reset()
  
  While OW_SearchROM_Enum(ID)=#True
    If (ID\Type = $28 Or ID\Type = $10) And AddElement(DS_List())
      DS_List()\ID = ID
      DS_List()\ErrCode = 255
      AddGadgetItem(#ListIcon_0, x, SN_Text(DS_List()\ID))
      x+1 ;  1    .
    EndIf
  Wend
  
EndProcedure

Procedure Timer() ;    
  RAM.OW_RAM
  x=0 ;   .
  
  ForEach DS_List()
    
    If DS_List()\ErrCode=0 ;   .
      If OW_SelectROM(DS_List()\ID) ;  .
        If OW_ReadRAM(RAM)          ;    .
          If OW_GetCRC(RAM, 8)=RAM\CRC
            
            DS_List()\Temp = PeekW(RAM) ;  ( ).
            
            ;  .
            If DS_List()\ID\Type = $28 ; DS18B20
              DS_List()\Temp / 16
            Else                       ; DS1820  DS18S20
              DS_List()\Temp / 2
            EndIf
            
            DS_List()\ErrCode = 0 ;   
          Else
            DS_List()\ErrCode = #OW_Err_CRC
          EndIf
        Else
          DS_List()\ErrCode = OW_GetLastError()
        EndIf
      Else
        DS_List()\ErrCode = OW_GetLastError()
      EndIf
    EndIf
    
    If DS_List()\ErrCode = 0
      SetGadgetItemText(#ListIcon_0, x, StrF(DS_List()\Temp, 1), 1)
    Else
      SetGadgetItemText(#ListIcon_0, x, GetErrString(DS_List()\ErrCode), 1)
      DS_List()\ErrCode = 0 ;   
    EndIf
    
    x+1 ;  1    .
  Next
  
  ;        .
  If OW_SkipROM()=0 Or OW_ConvertT()=0
    ForEach DS_List()
      DS_List()\ErrCode = OW_GetLastError()
    Next
  EndIf
  
EndProcedure

OpenWindow_0()

AddWindowTimer(#Window_0, 2, 1000) ;     1 .

Repeat
  Event = WaitWindowEvent()
  
  If Event = #PB_Event_Gadget
    
    Select EventGadget()
      Case #Combo_0    ;    COM .
        OW_OpenPort(GetGadgetText(#Combo_0)) ;  .
      Case  #Button_0  ;    .
        Find()         ;    
    EndSelect
    
  ElseIf Event = #PB_Event_Timer ;  .
    If EventTimer() = 2 ;     2.
      Timer()           ;    
    EndIf
  EndIf
  
Until Event = #PB_Event_CloseWindow
; IDE Options = PureBasic 5.24 LTS (Windows - x86)
; CursorPosition = 117
; FirstLine = 105
; Folding = -
; EnableAsm
; EnableXP
; Executable = TestTemp 1.1.exe
; HideErrorLog
; EnablePurifier
; EnableExeConstant